## ecere-sdk 0.44.10

=== Makefile ===
.PHONY: all clean realclean distclean emptyoutput prepinstall actualinstall install copyonlyinstall uninstall troubleshoot outputdirs bootstrap deps ecere ecerecom ecerevanilla ear compiler prepbinaries epj2make ide documentor eda prepcodeguard codeguard fixprecompile cleantarget pots installer regenbootstrap updatebootstrap update_ecere update_libec update_ecp update_ecc update_ecs ecereaudio
ifneq "$(V)" "1"
.SILENT:
endif

include crossplatform.mk
include default.cf

ifdef BSD_HOST
INSTALL_FLAGS :=
CPFLAGS := -pRf
else
INSTALL_FLAGS := -D
CPFLAGS := -dpRf
endif

XBOOT := $(if $(CROSS_TARGET),GCC_PREFIX= TARGET_PLATFORM=$(HOST_PLATFORM) PLATFORM=$(HOST_PLATFORM),)

LIBVER := .0.44

ifndef ECERE_AUDIO
ECERE_AUDIO := n

ifdef WINDOWS_TARGET
ECERE_AUDIO := y
endif

ifdef LINUX_TARGET
ifndef BSD_TARGET
ECERE_AUDIO := y
endif
endif
endif

ifdef WINDOWS_HOST
HOST_SOV := $(HOST_SO)
else
HOST_SOV := $(HOST_SO)$(LIBVER)
endif

ifdef WINDOWS_TARGET

SOV := $(SO)

ifndef DESTDIR

ifeq "$(TARGET_ARCH)" "x86_64"
   ifneq "$(wildcard $(SystemDrive)/Program\ Files )" ""
      export DESTDIR=$(SystemDrive)/Program Files/Ecere SDK
   else
      export DESTDIR=$(SystemDrive)/Ecere SDK
   endif
else
   ifdef ProgramFiles(x86)
      export DESTDIR=${ProgramFiles(x86)}/Ecere SDK
   else
      ifdef ProgramFiles
         export DESTDIR=$(ProgramFiles)/Ecere SDK
      else
         export DESTDIR=$(SystemDrive)/Ecere SDK
      endif
   endif
endif

endif # DESTDIR

export prefix=

ifndef DOCDIR
export DOCDIR=$(DESTDIR)$(prefix)/doc
endif

ifndef BINDIR
export BINDIR=$(DESTDIR)$(prefix)/bin
endif

ifndef LIBDIR
export LIBDIR=$(BINDIR)
endif
export DESTLIBDIR=$(LIBDIR)

ifndef SLIBDIR
export SLIBDIR=$(DESTDIR)$(prefix)/lib
endif
export DESTSLIBDIR=$(SLIBDIR)

ifndef SAMPLESDIR
export SAMPLESDIR=$(DESTDIR)$(prefix)/samples
endif

ifndef EXTRASDIR
export EXTRASDIR=$(DESTDIR)$(prefix)/extras
endif


else # WINDOWS_TARGET

ifdef OSX_TARGET
# TODO: OSX soname
SOV := $(SO)
else
SOV := $(SO)$(LIBVER)
endif

ifndef DESTDIR
export DESTDIR=
endif

ifndef prefix
export prefix=/usr
endif

ifndef DOCDIR
export DOCDIR=$(DESTDIR)$(prefix)/share/ecere/doc
endif

ifndef MANDIR
export MANDIR=$(DESTDIR)$(prefix)/share/man/
endif

ifndef BINDIR
export BINDIR=$(DESTDIR)$(prefix)/bin
endif

ifdef LIBDIR
 export PREFIXLIBDIR=$(LIBDIR)
else
 export PREFIXLIBDIR=$(prefix)/lib/$(TARGET_ARCH)

 ifeq "$(wildcard $(prefix)/lib/$(TARGET_ARCH) )" ""
  export PREFIXLIBDIR=$(prefix)/lib

  ifeq "$(TARGET_ARCH)" "i386-linux-gnu"
   ifneq "$(wildcard $(prefix)/lib32 )" ""
    export PREFIXLIBDIR=$(prefix)/lib32
   endif
  endif

 endif
endif

export CPPFLAGS
CPPFLAGS += -DDEB_HOST_MULTIARCH=\"$(call escspace,$(PREFIXLIBDIR))\"

DESTLIBDIR := $(DESTDIR)$(PREFIXLIBDIR)
ifdef SLIBDIR
DESTSLIBDIR := $(DESTDIR)$(SLIBDIR)
else
DESTSLIBDIR := $(DESTLIBDIR)
endif

ifndef SAMPLESDIR
export SAMPLESDIR=$(DESTDIR)$(prefix)/share/ecere/samples
endif

ifndef EXTRASDIR
export EXTRASDIR=$(DESTDIR)$(prefix)/share/ecere/extras
endif


endif

OBJDIR := obj$(OBJALT)/
OBJBINDIR := $(OBJDIR)$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/bin/
OBJLIBDIR := $(OBJDIR)$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/lib/
XOBJDIR := obj$(OBJALT)/
XOBJBINDIR := $(OBJDIR)$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/bin/
XOBJLIBDIR := $(OBJDIR)$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/lib/

all: prepbinaries ide epj2make documentor eda codeguard ecereaudio
	@$(call echo,The Ecere SDK is fully built.)

outputdirs:
	$(if $(wildcard $(OBJDIR)),,$(call mkdirq,$(OBJDIR)))
	$(if $(wildcard $(OBJBINDIR)),,$(call mkdirq,$(OBJBINDIR)))
	$(if $(wildcard $(OBJLIBDIR)),,$(call mkdirq,$(OBJLIBDIR)))
ifdef CROSS_TARGET
	$(if $(wildcard $(XOBJDIR)),,$(call mkdirq,$(XOBJDIR)))
	$(if $(wildcard $(XOBJBINDIR)),,$(call mkdirq,$(XOBJBINDIR)))
	$(if $(wildcard $(XOBJLIBDIR)),,$(call mkdirq,$(XOBJLIBDIR)))
endif

bootstrap: outputdirs
	cd compiler && $(MAKE) $(XBOOT) bootstrap

deps:
ifdef CROSS_TARGET
ifndef LINUX_HOST
	@$(call echo,Building dependencies (host)...)
	cd deps && $(MAKE) $(XBOOT)
endif
endif
ifndef LINUX_TARGET
	@$(call echo,Building dependencies...)
	cd deps && $(MAKE)
endif

ecere: bootstrap deps
ifdef CROSS_TARGET
	@$(call echo,Building 2nd stage ecere (host)...)
else
	@$(call echo,Building 2nd stage ecere...)
endif
	cd ecere && $(MAKE) nores $(XBOOT)
	cd ear && $(MAKE) nores $(XBOOT)
	cd ecere && $(MAKE) cleaneceretarget
ifdef CROSS_TARGET
	@$(call echo,Building 2nd stage ecere...)
endif
	cd ecere && $(MAKE)

ecerecom: bootstrap
ifdef CROSS_TARGET
	@$(call echo,Building eC Core Runtime (host)...)
	cd ecere && $(MAKE) -f Makefile.ecereCOM $(XBOOT)
endif
	@$(call echo,Building eC Core Runtime...)
	cd ecere && $(MAKE) -f Makefile.ecereCOM

ecerevanilla: bootstrap
	@$(call echo,Building Vanilla Ecere...)
	cd ecere && $(MAKE) -f Makefile.vanilla

ear: ecere ecerevanilla
	@$(call echo,Building ear...)
	cd ear && cd cmd && $(MAKE) cleantarget
	cd ear && $(MAKE)

fixprecompile:
	cd compiler && $(MAKE) fixprecompile

compiler: ecere ear
ifdef CROSS_TARGET
	@$(call echo,Building 2nd stage compiler (host))
	cd compiler && $(MAKE) $(XBOOT)
endif
	@$(call echo,Building 2nd stage compiler)
	cd compiler && $(MAKE)

prepbinaries: compiler ecerecom
	@$(call echo,Enabling 2nd stage binaries...)
ifdef WINDOWS_TARGET
	$(call cpq,ecere/obj/release.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(LP)ecere$(SOV),$(OBJBINDIR))
	$(call cpq,ecere/obj/ecereCOM.release.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(LP)ecereCOM$(SOV),$(OBJBINDIR))
	$(call cpq,compiler/libec/obj/release.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(LP)ec$(SOV),$(OBJBINDIR))
endif
ifdef LINUX_TARGET
	$(call cpq,ecere/obj/release.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(LP)ecere$(SOV),$(OBJLIBDIR))
	$(call cpq,ecere/obj/ecereCOM.release.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(LP)ecereCOM$(SOV),$(OBJLIBDIR))
	$(call cpq,compiler/libec/obj/release.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(LP)ec$(SOV),$(OBJLIBDIR))
	ln -sf $(LP)ecere$(SOV) $(OBJLIBDIR)$(LP)ecere$(SO).0
	ln -sf $(LP)ecereCOM$(SOV) $(OBJLIBDIR)$(LP)ecereCOM$(SO).0
	ln -sf $(LP)ec$(SOV) $(OBJLIBDIR)$(LP)ec$(SO).0
	ln -sf $(LP)ecere$(SOV) $(OBJLIBDIR)$(LP)ecere$(SO)
	ln -sf $(LP)ecereCOM$(SOV) $(OBJLIBDIR)$(LP)ecereCOM$(SO)
	ln -sf $(LP)ec$(SOV) $(OBJLIBDIR)$(LP)ec$(SO)
endif
ifndef WINDOWS_TARGET
ifndef LINUX_TARGET
	$(call cpq,ecere/obj/release.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(LP)ecere$(SO),$(OBJLIBDIR))
	$(call cpq,ecere/obj/ecereCOM.release.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(LP)ecereCOM$(SO),$(OBJLIBDIR))
	$(call cpq,compiler/libec/obj/release.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(LP)ec$(SO),$(OBJLIBDIR))
endif
endif
	$(call cpq,ear/cmd/obj/release.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/ear$(E),$(OBJBINDIR))
	$(call cpq,compiler/ecc/obj/release.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/ecc$(E),$(OBJBINDIR))
	$(call cpq,compiler/ecp/obj/release.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/ecp$(E),$(OBJBINDIR))
	$(call cpq,compiler/ecs/obj/release.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/ecs$(E),$(OBJBINDIR))

ifdef CROSS_TARGET

ifdef WINDOWS_HOST
	$(call cpq,ecere/obj/release.$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(HOST_LP)ecere$(HOST_SOV),$(XOBJBINDIR))
	$(call cpq,ecere/obj/ecereCOM.release.$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(HOST_LP)ecereCOM$(HOST_SOV),$(XOBJBINDIR))
	$(call cpq,compiler/libec/obj/release.$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(HOST_LP)ec$(HOST_SOV),$(XOBJBINDIR))
endif
ifdef WINDOWS_HOST
	$(call cpq,ecere/obj/release.$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(HOST_LP)ecere$(HOST_SOV),$(XOBJLIBDIR))
	$(call cpq,ecere/obj/ecereCOM.release.$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(HOST_LP)ecereCOM$(HOST_SOV),$(XOBJLIBDIR))
	$(call cpq,compiler/libec/obj/release.$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(HOST_LP)ec$(HOST_SOV),$(XOBJLIBDIR))
	ln -sf $(HOST_LP)ecere$(HOST_SOV) $(XOBJLIBDIR)$(LP)ecere$(HOST_SO).0
	ln -sf $(HOST_LP)ecereCOM$(HOST_SOV) $(XOBJLIBDIR)$(LP)ecereCOM$(HOST_SO).0
	ln -sf $(HOST_LP)ec$(HOST_SOV) $(XOBJLIBDIR)$(LP)ec$(HOST_SO).0
	ln -sf $(HOST_LP)ecere$(HOST_SOV) $(XOBJLIBDIR)$(LP)ecere$(HOST_SO)
	ln -sf $(HOST_LP)ecereCOM$(HOST_SOV) $(XOBJLIBDIR)$(LP)ecereCOM$(HOST_SO)
	ln -sf $(HOST_LP)ec$(HOST_SOV) $(XOBJLIBDIR)$(LP)ec$(HOST_SO)
endif
ifndef WINDOWS_HOST
ifndef LINUX_HOST
	$(call cpq,ecere/obj/release.$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(HOST_LP)ecere$(HOST_SO),$(XOBJLIBDIR))
	$(call cpq,ecere/obj/ecereCOM.release.$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(HOST_LP)ecereCOM$(HOST_SO),$(XOBJLIBDIR))
	$(call cpq,compiler/libec/obj/release.$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/$(HOST_LP)ec$(HOST_SO),$(XOBJLIBDIR))
endif
endif
	$(call cpq,ear/cmd/obj/release.$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/ear$(HOST_E),$(XOBJBINDIR))
	$(call cpq,compiler/ecc/obj/release.$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/ecc$(HOST_E),$(XOBJBINDIR))
	$(call cpq,compiler/ecp/obj/release.$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/ecp$(HOST_E),$(XOBJBINDIR))
	$(call cpq,compiler/ecs/obj/release.$(HOST_PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/ecs$(HOST_E),$(XOBJBINDIR))

endif

epj2make: prepbinaries
	@$(call echo,Building epj2make...)
	cd epj2make && $(MAKE)

ecereaudio: prepbinaries
ifneq "$(ECERE_AUDIO)" "n"
	@$(call echo,Building EcereAudio...)
	cd audio && $(MAKE)
endif

ide: prepbinaries
	@$(call echo,Building IDE...)
	cd ide && $(MAKE)

documentor: prepbinaries
	@$(call echo,Building Documentor...)
	cd documentor && $(MAKE)

codeguard: prepcodeguard
ifdef CodeGuard
	@$(call echo,Building CodeGuard client...)
	cd codeGuard && $(MAKE)
endif

prepcodeguard: eda
ifdef CodeGuard
ifdef WINDOWS_TARGET
	$(call cpq,eda/libeda/obj/release.$(PLATFORM)/$(LP)EDA$(SO),$(OBJBINDIR))
endif

ifdef LINUX_TARGET
	$(call cpq,eda/libeda/obj/release.$(PLATFORM)/$(LP)EDA$(SOV),$(OBJLIBDIR))
	ln -sf $(LP)EDA$(SOV) $(OBJLIBDIR)$(LP)EDA$(SO).0
	ln -sf $(LP)EDA$(SOV) $(OBJLIBDIR)$(LP)EDA$(SO)
endif

ifndef WINDOWS_TARGET
ifndef LINUX_TARGET
	$(call cpq,eda/libeda/obj/release.$(PLATFORM)/$(LP)EDA$(SO),$(OBJLIBDIR))
endif
endif
endif

eda: prepbinaries
ifdef CROSS_TARGET
	@$(call echo,Building EDA (host))
	cd eda && $(MAKE) $(XBOOT)
endif
	@$(call echo,Building EDA...)
	cd eda && $(MAKE)

emptyoutput: outputdirs
	$(call rmq,$(OBJLIBDIR)libecereVanilla$(A))
	$(call rmq,$(SODESTDIR)$(LP)ecere$(SO))
	$(call rmq,$(SODESTDIR)$(LP)ecereCOM$(SO))
	$(call rmq,$(SODESTDIR)$(LP)ec$(SO))
	$(call rmq,$(SODESTDIR)$(LP)EDA$(SO))
	$(call rmq,$(SODESTDIR)$(LP)EDASQLite$(SO))
ifdef EDASQLiteCipher
	$(call rmq,$(SODESTDIR)$(LP)EDASQLiteCipher$(SO))
endif
ifneq "$(ECERE_AUDIO)" "n"
	$(call rmq,$(SODESTDIR)$(LP)EcereAudio$(SO))
endif
ifdef LINUX_TARGET
	$(call rmq,$(SODESTDIR)$(LP)ecere$(SO).0)
	$(call rmq,$(SODESTDIR)$(LP)ecereCOM$(SO).0)
	$(call rmq,$(SODESTDIR)$(LP)ec$(SO).0)
	$(call rmq,$(SODESTDIR)$(LP)EDA$(SO).0)
	$(call rmq,$(SODESTDIR)$(LP)EDASQLite$(SO).0)
ifdef EDASQLiteCipher
	$(call rmq,$(SODESTDIR)$(LP)EDASQLiteCipher$(SO).0)
endif
ifneq "$(ECERE_AUDIO)" "n"
	$(call rmq,$(SODESTDIR)$(LP)EcereAudio$(SO).0)
endif
	$(call rmq,$(SODESTDIR)$(LP)ecere$(SOV))
	$(call rmq,$(SODESTDIR)$(LP)ecereCOM$(SOV))
	$(call rmq,$(SODESTDIR)$(LP)ec$(SOV))
	$(call rmq,$(SODESTDIR)$(LP)EDA$(SOV))
	$(call rmq,$(SODESTDIR)$(LP)EDASQLite$(SOV))
ifdef EDASQLiteCipher
	$(call rmq,$(SODESTDIR)$(LP)EDASQLiteCipher$(SOV))
endif
ifneq "$(ECERE_AUDIO)" "n"
	$(call rmq,$(SODESTDIR)$(LP)EcereAudio$(SOV))
endif
endif	
	$(call rmq,$(OBJBINDIR)ear$(E))
	$(call rmq,$(OBJBINDIR)ecc$(E))
	$(call rmq,$(OBJBINDIR)ecp$(E))
	$(call rmq,$(OBJBINDIR)ecs$(E))
	$(call rmq,$(OBJBINDIR)epj2make$(E))
	$(call rmq,$(OBJBINDIR)ide$(E))
	$(call rmq,$(OBJBINDIR)documentor$(E))
ifdef CodeGuard
	$(call rmq,$(OBJBINDIR)CodeGuard$(E))
endif

cleantarget:
	cd compiler && $(MAKE) cleantarget

=== ear/Makefile ===
ifneq "$(V)" "1"
.SILENT:
endif
.PHONY: all nores cleantarget clean realclean distclean

# CROSS-PLATFORM MAGIC

include ../crossplatform.mk
include ../default.cf

all:
	@$(call echo,Building self-extract tool...)
	cd extract && $(MAKE)
	@$(call echo,Building eAR command line tool...)
	cd cmd && $(MAKE)

nores:
	@$(call echo,Building eAR command line tool...)
	cd cmd && $(MAKE) nores

cleantarget:
	cd extract && $(MAKE) cleantarget
	cd cmd && $(MAKE) cleantarget

clean:
	cd extract && $(MAKE) clean
	cd cmd && $(MAKE) clean

realclean:
	cd extract && $(MAKE) realclean
	cd cmd && $(MAKE) realclean

distclean:
	cd extract && $(MAKE) distclean
	cd cmd && $(MAKE) distclean

=== eda/Makefile ===
ifneq "$(V)" "1"
.SILENT:
endif
.PHONY: all cmd cleantarget clean realclean distclean

# CROSS-PLATFORM MAGIC

_CF_DIR = ../

include $(_CF_DIR)crossplatform.mk
include $(_CF_DIR)default.cf

all:
	@$(call echo,Building Ecere Data Access layer...)
	cd libeda && $(MAKE)
	@$(call echo,Building EDASQLite driver...)
	cd drivers && cd sqlite && $(MAKE)
ifdef EDASQLiteCipher
	@$(call echo,Building EDASQLiteCipher driver...)
	cd drivers && cd sqliteCipher && $(MAKE)
endif

cleantarget:
	cd libeda && $(MAKE) cleantarget
	cd drivers && cd sqlite && $(MAKE) cleantarget
ifdef EDASQLiteCipher
	cd drivers && cd sqliteCipher && $(MAKE) cleantarget
endif

clean:
	cd libeda && $(MAKE) clean
	cd drivers && cd sqlite && $(MAKE) clean
ifdef EDASQLiteCipher
	cd drivers && cd sqliteCipher && $(MAKE) clean
endif

realclean:
	cd libeda && $(MAKE) realclean
	cd drivers && cd sqlite && $(MAKE) realclean
ifdef EDASQLiteCipher
	cd drivers && cd sqliteCipher && $(MAKE) realclean
endif

distclean:
	cd libeda && $(MAKE) distclean
	cd drivers && cd sqlite && $(MAKE) distclean
ifdef EDASQLiteCipher
	cd drivers && cd sqliteCipher && $(MAKE) distclean
endif

=== installer/Makefile ===
.PHONY: all objdir cleantarget clean realclean distclean pots

# CORE VARIABLES

MODULE := Installer
VERSION := 
CONFIG := release
ifndef COMPILER
COMPILER := default
endif

TARGET_TYPE = executable

# FLAGS

ECFLAGS =
ifndef DEBIAN_PACKAGE
CFLAGS =
LDFLAGS =
endif
PRJ_CFLAGS =
CECFLAGS =
OFLAGS =
LIBS =

ifdef DEBUG
NOSTRIP := y
endif

CONSOLE = -mwindows

# INCLUDES

_CF_DIR = ../

include $(_CF_DIR)crossplatform.mk
include $(_CF_DIR)default.cf

# POST-INCLUDES VARIABLES

OBJ = obj/$(CONFIG).$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/

RES = 

TARGET = obj/$(CONFIG).$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/setup-ecere-0.44.10-win32$(E)

_ECSOURCES = \
	src/installer.ec \
	../ide/src/IDESettings.ec \
	../ide/src/OldIDESettings.ec \
	../extras/gui/controls/StringsBox.ec \
	../ide/src/licensing.ec \
	../extras/createLink.ec \
	../extras/gui/controls/CheckListBox.ec

ECSOURCES = $(call shwspace,$(_ECSOURCES))

_COBJECTS = $(addprefix $(OBJ),$(patsubst %.ec,%$(C),$(notdir $(_ECSOURCES))))

_SYMBOLS = $(addprefix $(OBJ),$(patsubst %.ec,%$(S),$(notdir $(_ECSOURCES))))

_IMPORTS = $(addprefix $(OBJ),$(patsubst %.ec,%$(I),$(notdir $(_ECSOURCES))))

_ECOBJECTS = $(addprefix $(OBJ),$(patsubst %.ec,%$(O),$(notdir $(_ECSOURCES))))

_BOWLS = $(addprefix $(OBJ),$(patsubst %.ec,%$(B),$(notdir $(_ECSOURCES))))

COBJECTS = $(call shwspace,$(_COBJECTS))

SYMBOLS = $(call shwspace,$(_SYMBOLS))

IMPORTS = $(call shwspace,$(_IMPORTS))

ECOBJECTS = $(call shwspace,$(_ECOBJECTS))

BOWLS = $(call shwspace,$(_BOWLS))

ifdef WINDOWS_TARGET

_RCSOURCES = \
	../ide/src/resources.rc

RCSOURCES = $(call shwspace,$(_RCSOURCES))

RCOBJECTS = $(call shwspace,$(addprefix $(OBJ),$(patsubst %.rc,%$(O),$(notdir $(_RCSOURCES)))))

else
RCSOURCES =
RCOBJECTS =
endif

OBJECTS = $(ECOBJECTS) $(OBJ)$(MODULE).main$(O) $(RCOBJECTS)

SOURCES = $(ECSOURCES) $(RCSOURCES)

RESOURCES = $(RESOURCES1) $(RESOURCES2) $(RESOURCES3) $(RESOURCES4) $(RESOURCES5) $(RESOURCES6) $(RESOURCES7) $(RESOURCES8) $(RESOURCES9) $(RESOURCES10) $(RESOURCES11) $(RESOURCES12) $(RESOURCES13) $(RESOURCES14) $(RESOURCES15) $(RESOURCES16) $(RESOURCES17) $(RESOURCES18) $(RESOURCES19) $(RESOURCES20) $(RESOURCES21) $(RESOURCES22) $(RESOURCES23) $(RESOURCES24) $(RESOURCES25) $(RESOURCES26) $(RESOURCES27) $(RESOURCES28) $(RESOURCES29) $(RESOURCES30) $(RESOURCES31) $(RESOURCES32) $(RESOURCES33) $(RESOURCES34) $(RESOURCES35) $(RESOURCES36) $(RESOURCES37) $(RESOURCES38) $(RESOURCES39) $(RESOURCES40) $(RESOURCES41) $(RESOURCES42) $(RESOURCES43) $(RESOURCES44) $(RESOURCES45) $(RESOURCES46) $(RESOURCES47) $(RESOURCES48) $(RESOURCES49) $(RESOURCES50) $(RESOURCES51) $(RESOURCES52) $(RESOURCES53) $(RESOURCES54) $(RESOURCES55) $(RESOURCES56) $(RESOURCES57) $(RESOURCES58) $(RESOURCES59) $(RESOURCES60) $(RESOURCES61) $(RESOURCES62) $(RESOURCES63) $(RESOURCES64) $(RESOURCES65) $(RESOURCES66) $(RESOURCES67) $(RESOURCES68) $(RESOURCES69) $(RESOURCES70) $(RESOURCES71) $(RESOURCES72) $(RESOURCES73) $(RESOURCES74) $(RESOURCES75) $(RESOURCES76) $(RESOURCES77) $(RESOURCES78) $(RESOURCES79) $(RESOURCES80) $(RESOURCES81) $(RESOURCES82) $(RESOURCES83) $(RESOURCES84) $(RESOURCES85) $(RESOURCES86) $(RESOURCES87) $(RESOURCES88) $(RESOURCES89) $(RESOURCES90) $(RESOURCES91) $(RESOURCES92) $(RESOURCES93) $(RESOURCES94) $(RESOURCES95) $(RESOURCES96) $(RESOURCES97) $(RESOURCES98) $(RESOURCES99) $(RESOURCES100) $(RESOURCES101) $(RESOURCES102) $(RESOURCES103) $(RESOURCES104) $(RESOURCES105) $(RESOURCES106) $(RESOURCES107) $(RESOURCES108) $(RESOURCES109) $(RESOURCES110) $(RESOURCES111) $(RESOURCES112) $(RESOURCES113) $(RESOURCES114) $(RESOURCES115) $(RESOURCES116) $(RESOURCES117) $(RESOURCES118) $(RESOURCES119) $(RESOURCES120) $(RESOURCES121) $(RESOURCES122) $(RESOURCES123) $(RESOURCES124) $(RESOURCES125) $(RESOURCES126) $(RESOURCES127) $(RESOURCES128) $(RESOURCES129) $(RESOURCES130) $(RESOURCES131) $(RESOURCES132) $(RESOURCES133) $(RESOURCES134) $(RESOURCES135) $(RESOURCES136) $(RESOURCES137) $(RESOURCES138) $(RESOURCES139) $(RESOURCES140) $(RESOURCES141) $(RESOURCES142) $(RESOURCES143) $(RESOURCES144) $(RESOURCES145) $(RESOURCES146) $(RESOURCES147) $(RESOURCES148) $(RESOURCES149) $(RESOURCES150) $(RESOURCES151) $(RESOURCES152) $(RESOURCES153) $(RESOURCES154) $(RESOURCES155) $(RESOURCES156) $(RESOURCES157) $(RESOURCES158) $(RESOURCES159) $(RESOURCES160) $(RESOURCES161) $(RESOURCES162) $(RESOURCES163) $(RESOURCES164) $(RESOURCES165) $(RESOURCES166) $(RESOURCES167) $(RESOURCES168) $(RESOURCES169) $(RESOURCES170) $(RESOURCES171) $(RESOURCES172) $(RESOURCES173) $(RESOURCES174) $(RESOURCES175) $(RESOURCES176) $(RESOURCES177) $(RESOURCES178) $(RESOURCES179) $(RESOURCES180) $(RESOURCES181) $(RESOURCES182) $(RESOURCES183) $(RESOURCES184) $(RESOURCES185) $(RESOURCES186) $(RESOURCES187) $(RESOURCES188) $(RESOURCES189) $(RESOURCES190) $(RESOURCES191) $(RESOURCES192) $(RESOURCES193) $(RESOURCES194) $(RESOURCES195) $(RESOURCES196) $(RESOURCES197) $(RESOURCES198) $(RESOURCES199) $(RESOURCES200) $(RESOURCES201) $(RESOURCES202) $(RESOURCES203) $(RESOURCES204) $(RESOURCES205) $(RESOURCES206) $(RESOURCES207) $(RESOURCES208) $(RESOURCES209) $(RESOURCES210) $(RESOURCES211) $(RESOURCES212) $(RESOURCES213) $(RESOURCES214) $(RESOURCES215) $(RESOURCES216) $(RESOURCES217) $(RESOURCES218) $(RESOURCES219) $(RESOURCES220) $(RESOURCES221)
RESOURCES1 = \
	../ecere/res/elements/areaClose.png \
	../ecere/res/elements/areaMaximize.png \
	../ecere/res/elements/areaMinimize.png \
	../ecere/res/elements/areaRestore.png \
	../ecere/res/elements/arrowDown.png \
	../ecere/res/elements/arrowLeft.png \
	../ecere/res/elements/arrowRight.png \
	../ecere/res/elements/arrowUp.png \
	../ecere/res/unicode/derivedGeneralCategoryStripped.txt \
	../ecere/res/actions/folderNew.png \
	../ecere/res/actions/goUp.png \
	../ecere/res/devices/computer.png \
	../ecere/res/devices/driveHardDisk.png \
	../ecere/res/devices/driveRemovableMedia.png \
	../ecere/res/devices/mediaFloppy.png \
	../ecere/res/devices/mediaOptical.png \
	../ecere/res/mimeTypes/file.png \
	../ecere/res/mimeTypes/brokenFile.png \
	../ecere/res/places/driveRemote.png \
	../ecere/res/places/folder.png \
	../ecere/res/places/folderRemote.png \
	../ecere/res/places/networkServer.png \
	../ecere/res/places/networkWorkgroup.png \
	../ecere/res/places/brokenFolder.png \
	../ecere/res/status/folderOpen.png \
	../ecere/locale/es.mo \
	../ecere/locale/hu.mo \
	../ecere/locale/mr.mo \
	../ecere/locale/nl.mo \
	../ecere/locale/pt_BR.mo \
	../ecere/locale/ru.mo \
	../ecere/locale/zh_CN.mo \
	../obj/win32/bin/documentor.exe \
	../obj/win32/bin/ide.exe \
	../obj/win32/bin/ear.exe \
	../obj/win32/bin/ec.dll \
	../obj/win32/bin/ecc.exe \
	../obj/win32/bin/ecereCOM.dll \
	../obj/win32/bin/ecp.exe \
	../obj/win32/bin/ecs.exe \
	../obj/win32/bin/epj2make.exe \
	../obj/win32/bin/EDA.dll \
	../obj/win32/bin/EDASQLite.dll \
	../doc/ecere.eCdoc \
	../doc/ecereCOM.eCdoc
RESOURCES2 = \
	../doc/EDA.eCdoc \
	../LICENSE \
	../README \
	../doc/tao.pdf \
	coursework/Chapter\ 1\ -\ Getting\ Started/Lab1.1/helloWorld.ec \
	coursework/Chapter\ 1\ -\ Getting\ Started/Lab1.1/HelloWorld.epj \
	coursework/Chapter\ 1\ -\ Getting\ Started/Lab1.2/form1.ec \
	coursework/Chapter\ 1\ -\ Getting\ Started/Lab1.2/HelloForm.epj \
	coursework/Chapter\ 1\ -\ Getting\ Started/answers\ -\ chapter\ 1.odt \
	coursework/Chapter\ 1\ -\ Getting\ Started/exercises\ -\ chapter\ 1.odt \
	coursework/Chapter\ 2\ -\ Variables\ and\ Data\ Types/Lab2.4/lab2.ec \
	coursework/Chapter\ 2\ -\ Variables\ and\ Data\ Types/Lab2.4/Lab2.epj \
	coursework/Chapter\ 2\ -\ Variables\ and\ Data\ Types/Lab2.5/variables.ec \
	coursework/Chapter\ 2\ -\ Variables\ and\ Data\ Types/Lab2.5/VariablesApp.epj \
	coursework/Chapter\ 2\ -\ Variables\ and\ Data\ Types/answers\ -\ chapter\ 2.odt \
	coursework/Chapter\ 2\ -\ Variables\ and\ Data\ Types/exercises\ -\ chapter\ 2.odt \
	coursework/Chapter\ 3\ -\ Operators/Lab3/lab3.ec \
	coursework/Chapter\ 3\ -\ Operators/Lab3/Lab3.epj \
	coursework/Chapter\ 3\ -\ Operators/answers\ -\ chapter\ 3.odt \
	coursework/Chapter\ 3\ -\ Operators/exercises\ -\ chapter\ 3.odt \
	coursework/Chapter\ 4\ -\ Flow\ Control/Lab4/lab4.ec \
	coursework/Chapter\ 4\ -\ Flow\ Control/Lab4/Lab4.epj \
	coursework/Chapter\ 4\ -\ Flow\ Control/answers\ -\ chapter\ 4.odt \
	coursework/Chapter\ 4\ -\ Flow\ Control/exercises\ -\ chapter\ 4.odt \
	coursework/Chapter\ 5\ -\ Structures\ and\ Enumerations/Lab5/colors/lab5colors.ec
RESOURCES3 = \
	coursework/Chapter\ 5\ -\ Structures\ and\ Enumerations/Lab5/colors/lab5colors.epj \
	coursework/Chapter\ 5\ -\ Structures\ and\ Enumerations/Lab5/vectors/lab5vectors.ec \
	coursework/Chapter\ 5\ -\ Structures\ and\ Enumerations/Lab5/vectors/lab5vectors.epj \
	coursework/Chapter\ 5\ -\ Structures\ and\ Enumerations/answers\ -\ chapter\ 5.odt \
	coursework/Chapter\ 5\ -\ Structures\ and\ Enumerations/exercises\ -\ chapter\ 5.odt \
	coursework/Chapter\ 6\ -\ Classes,\ Methods\ and\ Instances/Lab6/lab6.ec \
	coursework/Chapter\ 6\ -\ Classes,\ Methods\ and\ Instances/Lab6/lab6.epj \
	coursework/Chapter\ 6\ -\ Classes,\ Methods\ and\ Instances/answers\ -\ chapter\ 6.odt \
	coursework/Chapter\ 6\ -\ Classes,\ Methods\ and\ Instances/exercises\ -\ chapter\ 6.odt \
	../obj/win32/bin/ecere.dll \
	../obj/win32/lib/libecereVanilla.a \
	../obj/win32/bin/EcereAudio.dll \
	upx391w/upx.exe \
	upx391w/BUGS \
	upx391w/COPYING \
	upx391w/LICENSE \
	upx391w/NEWS \
	upx391w/README \
	upx391w/README.1ST \
	upx391w/THANKS \
	upx391w/TODO \
	upx391w/upx.1 \
	upx391w/upx.doc \
	upx391w/upx.html \
	../samples/3D/Animate3DS/res/desktop.3ds \
	../samples/3D/Animate3DS/res/floor.jpg \
	../samples/3D/Animate3DS/res/wall_80.jpg \
	../samples/3D/Animate3DS/Animate3DS.ec \
	../samples/3D/Animate3DS/Animate3DS.epj \
	../samples/3D/ColorSpheres/colorSpheres.ec \
	../samples/3D/ColorSpheres/colorSpheres.epj \
	../samples/3D/cube2/cube2.ec \
	../samples/3D/cube2/cube2.epj
RESOURCES4 = \
	../samples/3D/cube2/knot.png \
	../samples/3D/cube2/fractal3.jpg \
	../samples/3D/glTriangle/glTriangle.ec \
	../samples/3D/glTriangle/glTriangle.epj \
	../samples/3D/hello3D/hello3D.ec \
	../samples/3D/hello3D/hello3D.epj \
	../samples/3D/HiraganaCube/FreeSans.ttf \
	../samples/3D/HiraganaCube/hiraganaCube.ec \
	../samples/3D/HiraganaCube/HiraganaCube.epj \
	../samples/3D/ModelViewer/res/ecere.png \
	../samples/3D/ModelViewer/res/help.txt \
	../samples/3D/ModelViewer/models/barn/barn.3DS \
	../samples/3D/ModelViewer/models/barn/Batten.jpg \
	../samples/3D/ModelViewer/models/barn/Boardbmp.jpg \
	../samples/3D/ModelViewer/models/barn/Boards.jpg \
	../samples/3D/ModelViewer/models/barn/Boards1.jpg \
	../samples/3D/ModelViewer/models/barn/Concrete.jpg \
	../samples/3D/ModelViewer/models/barn/cutout.jpg \
	../samples/3D/ModelViewer/models/barn/Finish.jpg \
	../samples/3D/ModelViewer/models/barn/FlWood.jpg \
	../samples/3D/ModelViewer/models/barn/Horizont.jpg \
	../samples/3D/ModelViewer/models/barn/OLDWOOD.jpg \
	../samples/3D/ModelViewer/models/barn/Read\ me_Old\ Barn.txt \
	../samples/3D/ModelViewer/models/barn/SANDSHOR.JPG \
	../samples/3D/ModelViewer/models/barn/Shadow.jpg \
	../samples/3D/ModelViewer/models/barn/STEELPLT.JPG \
	../samples/3D/ModelViewer/models/barn/Trellis.jpg \
	../samples/3D/ModelViewer/models/barn/Wood1.jpg \
	../samples/3D/ModelViewer/models/cart/Barrel.JPG \
	../samples/3D/ModelViewer/models/cart/cart.3DS \
	../samples/3D/ModelViewer/models/cart/Cart1.jpg
RESOURCES5 = \
	../samples/3D/ModelViewer/models/cart/Cart2.jpg \
	../samples/3D/ModelViewer/models/cart/Cart3.jpg \
	../samples/3D/ModelViewer/models/cart/metal_F.jpg \
	../samples/3D/ModelViewer/models/cart/MetCart1.jpg \
	../samples/3D/ModelViewer/models/cart/MetCart2.jpg \
	../samples/3D/ModelViewer/models/cart/OLDWOOD.JPG \
	../samples/3D/ModelViewer/models/cart/Read\ me_Cart\ For\ the\ Barn.txt \
	../samples/3D/ModelViewer/models/cart/WoodBr.jpg \
	../samples/3D/ModelViewer/models/cow/cow.3DS \
	../samples/3D/ModelViewer/models/cow/spot_tex.png \

=== compiler/bootstrap/Makefile ===
.PHONY: bindir ecere libec ecp ecc ecs cleantarget clean realclean distclean
ifneq "$(V)" "1"
.SILENT:
endif

OBJ = obj/bin.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/

include ../../crossplatform.mk
include ../../default.cf

all: bindir ecere libec ecp ecc ecs
	$(call cpq,ecp/obj/bootstrap.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/ecp$(E) ecc/obj/bootstrap.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/ecc$(E) ecs/obj/bootstrap.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/ecs$(E),$(OBJ))
	@$(call echo,All done!)

bindir:
	$(if $(wildcard $(OBJ)),,$(call mkdirq,$(OBJ)))

cleantarget: bindir
	$(call rmq,$(OBJ)ecp$(E) $(OBJ)ecc$(E) $(OBJ)ecs$(E))
ifdef WINDOWS_TARGET
	$(call rmq,$(OBJ)$(LP)ecere$(SO) $(OBJ)$(LP)ec$(SO))
endif

clean: cleantarget
	cd ecere && $(MAKE) clean
	cd libec && $(MAKE) clean
	cd ecp && $(MAKE) clean
	cd ecc && $(MAKE) clean
	cd ecs && $(MAKE) clean

realclean: cleantarget
	$(call rmrq,$(OBJ))
	cd ecere && $(MAKE) realclean
	cd libec && $(MAKE) realclean
	cd ecp && $(MAKE) realclean
	cd ecc && $(MAKE) realclean
	cd ecs && $(MAKE) realclean

distclean: cleantarget
	$(call rmrq,obj/)
	cd ecere && $(MAKE) distclean
	cd libec && $(MAKE) distclean
	cd ecp && $(MAKE) distclean
	cd ecc && $(MAKE) distclean
	cd ecs && $(MAKE) distclean

ecere:
	@$(call echo,Building ecere...)
	cd ecere && $(MAKE)
	
libec:
	@$(call echo,Building ec...)
	cd libec && $(MAKE)

ecp: ecere libec
	@$(call echo,Building ecp...)
	cd ecp && $(MAKE)

ecc: ecere libec
	@$(call echo,Building ecc...)
	cd ecc && $(MAKE)

ecs: ecere libec
	@$(call echo,Building ecs...)
	cd ecs && $(MAKE)

=== ear/extract/Makefile ===
.PHONY: all objdir cleantarget clean realclean distclean

# CORE VARIABLES

MODULE := extract
CONFIG := release
ifndef COMPILER
COMPILER := default
endif

TARGET_TYPE = executable

# FLAGS

ECFLAGS =
ifndef DEBIAN_PACKAGE
CFLAGS =
LDFLAGS =
endif
PRJ_CFLAGS =
CECFLAGS =
OFLAGS =
LIBS =

ifdef DEBUG
NOSTRIP := y
endif

CONSOLE = -mwindows

# INCLUDES

_CF_DIR = ../../
USE_BOOTSTRAP := defined

include $(_CF_DIR)crossplatform.mk
include $(_CF_DIR)default.cf

# POST-INCLUDES VARIABLES

OBJ = obj/$(CONFIG).$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/

RES = 

TARGET = obj/$(CONFIG).$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX)/extract$(E)

_ECSOURCES = \
	extract.ec

ECSOURCES = $(call shwspace,$(_ECSOURCES))

COBJECTS = $(call shwspace,$(addprefix $(OBJ),$(patsubst %.ec,%$(C),$(notdir $(_ECSOURCES)))))

SYMBOLS = $(call shwspace,$(addprefix $(OBJ),$(patsubst %.ec,%$(S),$(notdir $(_ECSOURCES)))))

IMPORTS = $(call shwspace,$(addprefix $(OBJ),$(patsubst %.ec,%$(I),$(notdir $(_ECSOURCES)))))

ECOBJECTS = $(call shwspace,$(addprefix $(OBJ),$(patsubst %.ec,%$(O),$(notdir $(_ECSOURCES)))))

BOWLS = $(call shwspace,$(addprefix $(OBJ),$(patsubst %.ec,%$(B),$(notdir $(_ECSOURCES)))))

OBJECTS = $(ECOBJECTS) $(OBJ)$(MODULE).main$(O)

SOURCES = $(ECSOURCES)

RESOURCES = $(RESOURCES1) $(RESOURCES2)
RESOURCES1 = \
	../../ecere/res/vanilla/ecere/actions/folderNew.png \
	../../ecere/res/vanilla/ecere/actions/goUp.png \
	../../ecere/res/vanilla/ecere/devices/computer.png \
	../../ecere/res/vanilla/ecere/devices/driveHardDisk.png \
	../../ecere/res/vanilla/ecere/devices/driveRemovableMedia.png \
	../../ecere/res/vanilla/ecere/devices/mediaFloppy.png \
	../../ecere/res/vanilla/ecere/devices/mediaOptical.png \
	../../ecere/res/vanilla/ecere/elements/areaClose.png \
	../../ecere/res/vanilla/ecere/elements/areaMaximize.png \
	../../ecere/res/vanilla/ecere/elements/areaMinimize.png \
	../../ecere/res/vanilla/ecere/elements/areaRestore.png \
	../../ecere/res/vanilla/ecere/elements/arrowDown.png \
	../../ecere/res/vanilla/ecere/elements/arrowLeft.png \
	../../ecere/res/vanilla/ecere/elements/arrowRight.png \
	../../ecere/res/vanilla/ecere/elements/arrowUp.png \
	../../ecere/res/vanilla/ecere/elements/optionBoxDisabledSelected.png \
	../../ecere/res/vanilla/ecere/elements/optionBoxDown.png \
	../../ecere/res/vanilla/ecere/elements/optionBoxSelected.png \
	../../ecere/res/vanilla/ecere/elements/optionBoxSelectedDown.png \
	../../ecere/res/vanilla/ecere/elements/optionBoxUp.png \
	../../ecere/res/vanilla/ecere/places/driveRemote.png \
	../../ecere/res/vanilla/ecere/places/folder.png \
	../../ecere/res/vanilla/ecere/places/folderRemote.png \
	../../ecere/res/vanilla/ecere/places/networkServer.png \
	../../ecere/res/vanilla/ecere/places/networkWorkgroup.png \
	../../ecere/res/vanilla/ecere/status/folderOpen.png \
	../../ecere/locale/es.mo
RESOURCES2 = \
	../../ecere/locale/hu.mo \
	../../ecere/locale/mr.mo \
	../../ecere/locale/nl.mo \
	../../ecere/locale/pt_BR.mo \
	../../ecere/locale/ru.mo \
	../../ecere/locale/zh_CN.mo \
	locale/es.mo \
	locale/he.mo \
	locale/ru.mo \
	locale/zh_CN.mo

LIBS += $(SHAREDLIB) $(EXECUTABLE) $(LINKOPT)

ifndef STATIC_LIBRARY_TARGET
LIBS += \
	$(call _L,ecereVanilla) \
	$(call _L,z)
endif

PRJ_CFLAGS += \
	 $(if $(DEBUG), -g, -Os) $(FPIC) -w \
			 -DECERE_STATIC

ECFLAGS += -module $(MODULE)
ECFLAGS += \
	 -nolinenumbers

# PLATFORM-SPECIFIC OPTIONS

ifdef WINDOWS_TARGET

ifndef STATIC_LIBRARY_TARGET
LIBS += \
	$(call _L,mpr) \
	$(call _L,winmm) \
	$(call _L,imm32) \
	$(call _L,gdi32)
endif

else
ifdef LINUX_TARGET

ifndef STATIC_LIBRARY_TARGET
OFLAGS += \
	 -L/usr/X11R6/lib
LIBS += \
	$(call _L,fontconfig) \
	$(call _L,freetype) \
	$(call _L,Xrender) \
	$(call _L,Xext) \
	$(call _L,ncurses) \
	$(call _L,m) \
	$(call _L,dl) \
	$(call _L,pthread) \
	$(call _L,X11)
endif

else
ifdef OSX_TARGET

ifndef STATIC_LIBRARY_TARGET
OFLAGS += \
	 -L/usr/X11R6/lib
LIBS += \
	$(call _L,fontconfig) \
	$(call _L,freetype) \
	$(call _L,Xrender) \
	$(call _L,Xext) \
	$(call _L,ncurses) \
	$(call _L,m) \
	$(call _L,dl) \
	$(call _L,pthread) \
	$(call _L,X11)
endif

endif
endif
endif

CECFLAGS += -cpp $(_CPP)

ifndef STATIC_LIBRARY_TARGET
OFLAGS += \
	 -L../../ecere/obj/vanilla.$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX) \
	 -L../../deps/zlib-1.2.8/obj/release.$(PLATFORM)$(COMPILER_SUFFIX)
endif

# TARGETS

all: objdir $(TARGET)

objdir:
	$(if $(wildcard $(OBJ)),,$(call mkdirq,$(OBJ)))

$(OBJ)$(MODULE).main.ec: $(SYMBOLS) $(COBJECTS)
	$(ECS) $(ARCH_FLAGS) $(ECSLIBOPT) $(SYMBOLS) $(IMPORTS) -symbols obj/$(CONFIG).$(PLATFORM)$(COMPILER_SUFFIX)$(DEBUG_SUFFIX) -o $(OBJ)$(MODULE).main.ec

$(OBJ)$(MODULE).main.c: $(OBJ)$(MODULE).main.ec
	$(ECP) $(CFLAGS) $(CECFLAGS) $(ECFLAGS) $(PRJ_CFLAGS) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.sym -symbols $(OBJ)
	$(ECC) $(CFLAGS) $(CECFLAGS) $(ECFLAGS) $(PRJ_CFLAGS) $(FVISIBILITY) -c $(OBJ)$(MODULE).main.ec -o $(OBJ)$(MODULE).main.c -symbols $(OBJ)

$(SYMBOLS): | objdir
$(OBJECTS): | objdir
$(TARGET): $(SOURCES) $(RESOURCES) $(SYMBOLS) $(OBJECTS) | objdir
ifndef STATIC_LIBRARY_TARGET
	$(CC) $(OFLAGS) $(OBJECTS) $(LIBS) -o $(TARGET) $(INSTALLNAME)
ifndef NOSTRIP
	$(STRIP) $(STRIPOPT) $(TARGET)
endif
ifndef WINDOWS_TARGET
ifdef EXECUTABLE_TARGET
	@-$(call sys_path,$(UPX) $(UPXFLAGS) $(TARGET)) || $(call echo,upx not installed; not compressing.)
endif
else
	@-$(call sys_path,$(UPX) $(UPXFLAGS) $(TARGET)) || $(call echo,upx not installed; not compressing.)
endif
	$(EAR) aw$(EARFLAGS) $(TARGET) ../../ecere/res/vanilla/ecere/actions/folderNew.png ../../ecere/res/vanilla/ecere/actions/goUp.png "ecere/actions"
	$(EAR) aw$(EARFLAGS) $(TARGET) ../../ecere/res/vanilla/ecere/devices/computer.png ../../ecere/res/vanilla/ecere/devices/driveHardDisk.png ../../ecere/res/vanilla/ecere/devices/driveRemovableMedia.png ../../ecere/res/vanilla/ecere/devices/mediaFloppy.png ../../ecere/res/vanilla/ecere/devices/mediaOptical.png "ecere/devices"
	$(EAR) aw$(EARFLAGS) $(TARGET) ../../ecere/res/vanilla/ecere/elements/areaClose.png ../../ecere/res/vanilla/ecere/elements/areaMaximize.png ../../ecere/res/vanilla/ecere/elements/areaMinimize.png ../../ecere/res/vanilla/ecere/elements/areaRestore.png ../../ecere/res/vanilla/ecere/elements/arrowDown.png ../../ecere/res/vanilla/ecere/elements/arrowLeft.png ../../ecere/res/vanilla/ecere/elements/arrowRight.png ../../ecere/res/vanilla/ecere/elements/arrowUp.png ../../ecere/res/vanilla/ecere/elements/optionBoxDisabledSelected.png ../../ecere/res/vanilla/ecere/elements/optionBoxDown.png "ecere/elements"
	$(EAR) aw$(EARFLAGS) $(TARGET) ../../ecere/res/vanilla/ecere/elements/optionBoxSelected.png ../../ecere/res/vanilla/ecere/elements/optionBoxSelectedDown.png ../../ecere/res/vanilla/ecere/elements/optionBoxUp.png "ecere/elements"
	$(EAR) aw$(EARFLAGS) $(TARGET) ../../ecere/res/vanilla/ecere/places/driveRemote.png ../../ecere/res/vanilla/ecere/places/folder.png ../../ecere/res/vanilla/ecere/places/folderRemote.png ../../ecere/res/vanilla/ecere/places/networkServer.png ../../ecere/res/vanilla/ecere/places/networkWorkgroup.png "ecere/places"
	$(EAR) aw$(EARFLAGS) $(TARGET) ../../ecere/res/vanilla/ecere/status/folderOpen.png "ecere/status"
	$(EAR) aw$(EARFLAGS) $(TARGET) ../../ecere/locale/es.mo ../../ecere/locale/hu.mo ../../ecere/locale/mr.mo ../../ecere/locale/nl.mo ../../ecere/locale/pt_BR.mo ../../ecere/locale/ru.mo ../../ecere/locale/zh_CN.mo "ecere/locale"
	$(EAR) aw$(EARFLAGS) $(TARGET) locale/es.mo locale/he.mo locale/ru.mo locale/zh_CN.mo "locale"
else
	$(AR) rcs $(TARGET) $(OBJECTS) $(LIBS)
endif

# SYMBOL RULES

$(OBJ)extract.sym: extract.ec
	$(ECP) $(CFLAGS) $(CECFLAGS) $(ECFLAGS) $(PRJ_CFLAGS) -c extract.ec -o $(OBJ)extract.sym

# C OBJECT RULES

$(OBJ)extract.c: extract.ec $(OBJ)extract.sym | $(SYMBOLS)
	$(ECC) $(CFLAGS) $(CECFLAGS) $(ECFLAGS) $(PRJ_CFLAGS) $(FVISIBILITY) -c extract.ec -o $(OBJ)extract.c -symbols $(OBJ)

# OBJECT RULES

$(OBJ)extract.o: $(OBJ)extract.c
	$(CC) $(CFLAGS) $(PRJ_CFLAGS) $(FVISIBILITY) -c $(OBJ)extract.c -o $(OBJ)extract.o

$(OBJ)$(MODULE).main$(O): $(OBJ)$(MODULE).main.c
	$(CC) $(CFLAGS) $(PRJ_CFLAGS) $(FVISIBILITY) -c $(OBJ)$(MODULE).main.c -o $(OBJ)$(MODULE).main$(O)

cleantarget: objdir
	$(call rmq,$(OBJ)$(MODULE).main.o $(OBJ)$(MODULE).main.c $(OBJ)$(MODULE).main.ec $(OBJ)$(MODULE).main$(I) $(OBJ)$(MODULE).main$(S))
	$(call rmq,$(OBJ)symbols.lst)
	$(call rmq,$(OBJ)objects.lst)
	$(call rmq,$(TARGET))
ifdef SHARED_LIBRARY_TARGET
ifdef LINUX_TARGET
ifdef LINUX_HOST
	$(call rmq,$(OBJ)$(LP)$(MODULE)$(SO)$(basename $(VER)))
	$(call rmq,$(OBJ)$(LP)$(MODULE)$(SO))
endif
endif
endif

clean: cleantarget
	$(call rmq,$(_OBJECTS))
	$(call rmq,$(ECOBJECTS))
	$(call rmq,$(COBJECTS))
	$(call rmq,$(BOWLS))
	$(call rmq,$(IMPORTS))
	$(call rmq,$(SYMBOLS))

realclean: cleantarget
	$(call rmrq,$(OBJ))

distclean: cleantarget
	$(call rmrq,obj/)

=== debian/changelog ===
ecere-sdk (0.44.10-1) unstable; urgency=low

  [Jerome St-Louis]
  * Build-Depend on libjpeg-dev (Closes: #750066)
  * Build-Depedn on libpng-dev (Closes: #750068)
  * New upstream version (Closes: #749822, #766189)
   + Compiler fixes and optimizations
   + Better C99 compatibility (stdbool, complex numbers)
   + Fixed C integer promotion issues
   + Fixed and improved all samples (resources included)
   + Improved 3DS model support
   + EditBox and syntax highlighting fixes
   + Internationalization improvements
   + Clang and OS X Mavericks Support
   + More reliable IDE debugger watches
   + X11 full screen support
   + X11 acquired input support
   + X11 fixes (including improved fix for Unity)
   + Various bug fixes
   + Memory leaks fixes

  [Ondřej Surý]
  * Don't bump the versions in the symbols files

 -- Jerome St-Louis <jerstlouis@gmail.com>  Thu, 7 Aug 2014 17:00:00 -0500

=== debian/control ===
Source: ecere-sdk
Section: devel
Priority: optional
Maintainer: Jerome St-Louis <jerstlouis@gmail.com>
Build-Depends: debhelper (>= 9~),
               dh-exec (>= 0.3~),
               dpkg-dev (>= 1.16.1~),
               libasound2-dev,
               libffi-dev,
               libfontconfig1-dev,
               libfreetype6-dev,
               libgif-dev,
               libgl1-mesa-dev,
               libgl1-mesa-glx,
               libjpeg-dev,
               libncurses5-dev,
               libpng-dev,
               libsqlite3-dev,
               libx11-dev,
               libxext-dev,
               libxrender-dev,
               linux-libc-dev,
               upx-ucl,
               zlib1g-dev
Standards-Version: 3.9.5
Homepage: http://ecere.org/

Package: ecere-sdk
Architecture: any
Depends: ecere-dev, ${devel:Depends}, ${misc:Depends}, ${shlibs:Depends}
Recommends: ecere-extras, ecere-samples, libeda0, libedasqlite0, libecereaudio0
Description: Ecere cross-platform SDK
 This package is a metapackage providing
 the entire Ecere cross-platform SDK
 (ecere-dev, ecere-samples, ecere-extras,
 libeda0, libedasqlite0).

Package: ecere-dev
Architecture: any
Recommends: fonts-freefont-ttf
Depends: libecc0 (= ${binary:Version}),
         libecerecom0 (= ${binary:Version}),
         ${devel:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: Ecere SDK Development Tools
 This package provides the compiling tools
 for the eC language, the Ecere IDE,
 as well as the symlinks for the Ecere
 libraries.

Package: libecere0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: multiarch-support
Depends: ${devel:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Ecere Runtime Library
 This package provides the Linux version
 of Ecere's cross-platform runtime library
 for running applications built using the
 Ecere SDK. It includes a GUI toolkit,
 2D/3D graphics engine, networking engine
 as well as system functionality.

Package: libecerecom0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: multiarch-support
Depends: ${devel:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: eC Core Runtime Library
 This package provides the bare minimum
 runtime library for applications
 written in eC.

Package: libecc0
Section: libs
Architecture: any
Multi-Arch: same
Replaces: libec0 (<= 0.44.02-1)
Breaks: libec0 (<= 0.44.02-1)
Pre-Depends: multiarch-support
Depends: libecere0 (= ${binary:Version}),
         ${devel:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: eC Compiler Library
 This package provides the eC compiler.
 It is used by the Ecere IDE, as well
 as the eC compiling tools (ecp, ecc, ecs).
 It could also be used by applications
 wanting to parse or compile eC code.

Package: libeda0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: multiarch-support
Depends: libecere0, ${devel:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Ecere Data Access
 This package provides the Ecere
 Data Access RDBMS abstraction layer.
 The Ecere Database (EDB) engine is built-in.
 For SQLite support, the SQLite driver
 (libedasqlite0) is also required.

Package: libedasqlite0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: multiarch-support
Depends: libeda0, ${devel:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: EDA SQLite Driver
 This package provides SQLite driver
 for building database applications
 with the Ecere Database Access layer.

Package: libecereaudio0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: multiarch-support
Depends: libecere0, ${devel:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Ecere Audio
 This package provides an audio playback and mixer API
 as well as support for basic .wav sound files.
 It makes use of ALSA.

Package: ecere-samples
Architecture: all
Multi-Arch: foreign
Depends: ${devel:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Project samples for the Ecere SDK
 This package contains samples for
 multimedia, database, graphics,
 communication, and other useful
 software that can be created with
 the Ecere SDK.

Package: ecere-extras
Architecture: all
Multi-Arch: foreign
Depends: ${devel:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: Extras for the Ecere SDK
 This package provides miscellaneous utilities
 not yet part of any library in the form of
 source code.
